package com.gic.haoban.manage.api.service;

import java.util.List;
import java.util.Set;

import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.manage.api.dto.QywxCorpInfoSimpleDTO;
import com.gic.haoban.manage.api.dto.WxEnterpriseDTO;
import com.gic.haoban.manage.api.dto.YwWxEnterpriseDTO;

public interface WxEnterpriseApiService {

	/**
	 * 接收企业回调信息
	 * @param dto
	 */
	void callbackReviceEnterprise(QywxCorpInfoSimpleDTO dto);
	/**
	 * 运维后台获取微信企业id列表
	 * @return
	 */
	com.gic.api.base.commons.Page<YwWxEnterpriseDTO> list(BasePageInfo pageInfo,String keyword,List<String> enterpriseIds,Integer gicContactFlag,String version);
	/**
	 * 获取一个
	 * @param wxEnterpriseId
	 * @return
	 */
	WxEnterpriseDTO getOne(String wxEnterpriseId);

	WxEnterpriseDTO getEnterpriseBycorpId(String corpId);
	/**
	 * 更新企业
	 * @param enterpriseDTO
	 */
	void update(WxEnterpriseDTO enterpriseDTO);
	
	List<YwWxEnterpriseDTO> listAll();
	
	List<YwWxEnterpriseDTO> listByIds(Set<String> enterpriseIds);
	
	boolean enterpriseIsOver(String enterpriseId);
}
