package com.gic.haoban.manage.service.service.out.impl;

import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;

import org.apache.commons.lang3.StringUtils;
import org.apache.http.client.utils.URLEncodedUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

import cn.hutool.core.collection.CollectionUtil;

import com.alibaba.fastjson.JSONObject;
import com.gic.clerk.api.dto.ClerkDTO;
import com.gic.clerk.api.service.ClerkService;
import com.gic.commons.util.EntityUtil;
import com.gic.enterprise.api.dto.MessageDTO;
import com.gic.haoban.manage.api.dto.ApplicationDTO;
import com.gic.haoban.manage.api.dto.StaffDepartmentRelatedDTO;
import com.gic.haoban.manage.api.enums.AppPageType;
import com.gic.haoban.manage.api.service.ApplicationApiService;
import com.gic.haoban.manage.api.service.StaffDepartmentRelatedApiService;
import com.gic.haoban.manage.service.config.Config;
import com.gic.haoban.manage.service.dao.mapper.StaffDepartmentRelatedMapper;
import com.gic.haoban.manage.service.dao.mapper.TabHaobanStaffClerkRelationMapper;
import com.gic.haoban.manage.service.dao.mapper.WxEnterpriseMapper;
import com.gic.haoban.manage.service.dao.mapper.WxEnterpriseRelatedMapper;
import com.gic.haoban.manage.service.entity.TabHaobanApplication;
import com.gic.haoban.manage.service.entity.TabHaobanDepartment;
import com.gic.haoban.manage.service.entity.TabHaobanStaffClerkRelation;
import com.gic.haoban.manage.service.entity.TabHaobanStaffDepartmentRelated;
import com.gic.haoban.manage.service.entity.TabHaobanWxEnterprise;
import com.gic.haoban.manage.service.entity.TabHaobanWxEnterpriseRelated;
import com.gic.haoban.manage.service.service.ApplicationService;
import com.gic.haoban.manage.service.service.DepartmentService;
import com.gic.haoban.manage.service.service.StaffDepartmentRelatedService;
import com.gic.wechat.api.dto.qywx.ItemDTO;
import com.gic.wechat.api.dto.qywx.QywxXcxSendMessageDTO;
import com.gic.wechat.api.service.qywx.QywxSuiteApiService;

import org.springframework.stereotype.Service;

@Service	
public class StaffDepartmentRelatedApiServiceImpl implements StaffDepartmentRelatedApiService {
    private static Logger logger= LoggerFactory.getLogger(StaffDepartmentRelatedApiServiceImpl.class);

	@Autowired
	private StaffDepartmentRelatedService staffDepartmentRelatedService;
	@Autowired
	private StaffDepartmentRelatedMapper staffDepartmentRelatedMapper;
	@Autowired
	private ClerkService clerkService;
	@Autowired
	private QywxSuiteApiService qywxSuiteApiService;
	@Autowired
	private WxEnterpriseMapper wxEnterpriseMapper;
	@Autowired
	private WxEnterpriseRelatedMapper wxEnterpriseRelatedMapper;
	@Autowired
	private DepartmentService departmentService;
	@Autowired
	private Config config;
	@Autowired
	private TabHaobanStaffClerkRelationMapper tabHaobanStaffClerkRelationMapper;
	
	@Override
	public List<StaffDepartmentRelatedDTO> listByDepartmentId(
			String departmentId) {
		List<TabHaobanStaffDepartmentRelated> list = staffDepartmentRelatedService.listByDepartmentId(departmentId);
		List<StaffDepartmentRelatedDTO> resultList = EntityUtil.changeEntityListByJSON(StaffDepartmentRelatedDTO.class, list);
		return resultList;
	}

	@Override
	public void updateById(StaffDepartmentRelatedDTO dto) {
		TabHaobanStaffDepartmentRelated tab = EntityUtil.changeEntityByJSON(TabHaobanStaffDepartmentRelated.class, dto);
		staffDepartmentRelatedMapper.updateByPrimaryKeySelective(tab);
	}

	@Override
	public void deleteCode(StaffDepartmentRelatedDTO dto) {
		staffDepartmentRelatedMapper.deleteCode(EntityUtil.changeEntityByJSON(TabHaobanStaffDepartmentRelated.class, dto));		
	}

	@Override
	public StaffDepartmentRelatedDTO getByStaffDepartmentRelatedId(String staffDepartmentRelatedId) {
		TabHaobanStaffDepartmentRelated tab = staffDepartmentRelatedMapper.getById(staffDepartmentRelatedId);
		if(Objects.isNull(tab)){
			return null;
		}
		StaffDepartmentRelatedDTO dto = EntityUtil.changeEntity(StaffDepartmentRelatedDTO.class, tab);
		return dto;
	}

	@Override
	public List<StaffDepartmentRelatedDTO> listByStaffId(String staffId) {
		List<TabHaobanStaffDepartmentRelated> list = staffDepartmentRelatedMapper.listStaffDepartmentByStaffId(staffId);
		if(CollectionUtil.isEmpty(list)){
			return new ArrayList<StaffDepartmentRelatedDTO>();
		}
		List<StaffDepartmentRelatedDTO> resultList = EntityUtil.changeEntityListByJSON(StaffDepartmentRelatedDTO.class, list);
		return resultList;
	}
	
	@Override
	public List<StaffDepartmentRelatedDTO> listByStaffIds(List<String> staffIds) {
		List<TabHaobanStaffDepartmentRelated> list = staffDepartmentRelatedMapper.listStaffDepartmentByStaffIds(staffIds);
		if(CollectionUtil.isEmpty(list)){
			return new ArrayList<StaffDepartmentRelatedDTO>();
		}
		List<StaffDepartmentRelatedDTO> resultList = EntityUtil.changeEntityListByJSON(StaffDepartmentRelatedDTO.class, list);
		return resultList;
	}

	@Override
	public StaffDepartmentRelatedDTO getOneByClerkCodeAndDepartmentId(String clerkCode, String departmentId) {
		TabHaobanStaffDepartmentRelated tab = staffDepartmentRelatedMapper.getDepartmentIdAndCode(departmentId,clerkCode);
		if(tab== null){
			return null;
		}
		StaffDepartmentRelatedDTO dto = EntityUtil.changeEntity(StaffDepartmentRelatedDTO.class, tab);
		return dto;
	}
	@Override
	public StaffDepartmentRelatedDTO getOneByStaffIdAndDepartmentId(String staffId, String departmentId) {
		TabHaobanStaffDepartmentRelated tab = staffDepartmentRelatedMapper.getDepartmentIdAndStaffId(departmentId,staffId);
		if(tab== null){
			return null;
		}
		StaffDepartmentRelatedDTO dto = EntityUtil.changeEntity(StaffDepartmentRelatedDTO.class, tab);
		return dto;
	}

	@Override
	public Map<String,String> getWxUserIdByClerkId(String clerkId) {
		Map<String,String> map  = new HashMap<>();
		
		TabHaobanStaffClerkRelation tab = tabHaobanStaffClerkRelationMapper.getOneByClerkId(clerkId);
		if(tab == null){
			return map;
		}
		ClerkDTO clerkDTO = clerkService.getclerkById(clerkId);
		if(clerkDTO == null){
			return map;
		}
		TabHaobanWxEnterprise tabHaobanWxEnterprise = wxEnterpriseMapper.selectByPrimaryKey(tab.getWxEnterpriseId());
		map.put("wxUserId", tab.getWxUserId());
		map.put("wxEnterpriseId", tab.getWxEnterpriseId());
		map.put("corpId", tabHaobanWxEnterprise.getCorpid());
		map.put("clerkName",clerkDTO.getClerkName());
		return map;
	}
	//导购绑定，，审核记录，，消息发送
	public void sendClerkBind(String clerkId,String clerkCode,int auditStatus,String auditReason){
        //TODO huang 发送申请人，我的记录页
		ClerkDTO clerk = clerkService.getclerkById(clerkId);
		if(clerk == null){
			logger.info("导购不存在，发送消息失败{}",clerkId);
		}
        String messageTitle = "门店账号申请";
		String messageContent = clerk.getClerkName()+"申请关联导购code（"+clerkCode+"）";
		JSONObject jsonObject = new JSONObject();
		jsonObject.put("storeId", clerk.getStoreId());
		String data = jsonObject.toJSONString();
		String pageUrl = this.getPageUrl(AppPageType.MY_RELATED_RECORD.getCode(), data);
		this.sendAuditMessage(clerkId, messageTitle, messageContent, pageUrl, auditStatus, auditReason);
	}
	
	
	//导购新增，，审核记录，，消息发送
	public void sendClerkAdd (String clerkId,String clerkCode,int auditStatus,String auditReason){
        //TODO huang 发送店长，门店关联记录列表
		ClerkDTO clerk = clerkService.getclerkById(clerkId);
		if(clerk == null){
			logger.info("导购不存在，发送消息失败{}",clerkId);
		}
        String messageTitle = "门店导购变更";
		String messageContent ="新增导购："+ clerk.getClerkName()+"（"+clerkCode+"）";
		JSONObject jsonObject = new JSONObject();
		jsonObject.put("storeId", clerk.getStoreId());
		String data = jsonObject.toJSONString();
        ClerkDTO gicClerk = clerkService.getClerkLeaderByStoreId(clerk.getStoreId());
		if(gicClerk == null){
			logger.info("店长不存在，发送消息失败{}",clerk.getStoreId());
		}
		String pageUrl = this.getPageUrl(AppPageType.STORE_RELATED_RECORD.getCode(), data);
		this.sendAuditMessage(gicClerk.getClerkId(), messageTitle, messageContent, pageUrl,auditStatus,"");
	}
	
	//导购删除，，审核记录，，消息发送
	public void sendClerkDel (String clerkId,String clerkCode,int auditStatus,String auditReason){
        //TODO huang 发送店长，门店关联记录列表
		ClerkDTO clerk = clerkService.getclerkById(clerkId);
		if(clerk == null){
			logger.info("导购不存在，发送消息失败{}",clerkId);
		}
        String messageTitle = "门店导购变更";
		String messageContent ="删除导购："+ clerk.getClerkName()+"（"+clerkCode+"）";
		JSONObject jsonObject = new JSONObject();
		jsonObject.put("storeId", clerk.getStoreId());
		String data = jsonObject.toJSONString();
        ClerkDTO gicClerk = clerkService.getClerkLeaderByStoreId(clerk.getStoreId());
		if(gicClerk == null){
			logger.info("店长不存在，发送消息失败{}",clerk.getStoreId());
		}
		String pageUrl = this.getPageUrl(AppPageType.STORE_RELATED_RECORD.getCode(), data);
		this.sendAuditMessage(gicClerk.getClerkId(), messageTitle, messageContent, pageUrl,auditStatus,"");
	}
	@Override
	public boolean sendSingleMessage(String clerkId, String title,
			String content, String pageUrl) {
		Map<String,String> map = getWxUserIdByClerkId(clerkId);
		String wxUserId = map.get("wxUserId");
		String corpId = map.get("corpId");
		String name = map.get("clerkName");

		if(jodd.util.StringUtil.isEmpty(wxUserId)){
			logger.info("wxUserId不存在============clerkId={}",clerkId);
			return false;
		}
		if(content.length()>30){
			content = content.substring(0, 26);
			content = content+"...";
		}
		//先发送下，试试
		QywxXcxSendMessageDTO messageDTO = new QywxXcxSendMessageDTO();
		List<ItemDTO> items = new ArrayList();;
		ItemDTO dto1 = new ItemDTO();
		ItemDTO dto2 = new ItemDTO();
		dto1.setKey("接收人");
		dto1.setValue(name);
		dto2.setKey("接收事件");
		dto2.setValue(content);
		items.add(dto1);
		items.add(dto2);
        ArrayList<String> list = new ArrayList<>();
        list.add(wxUserId);
		messageDTO.setAppid(config.getAppid());
        messageDTO.setUserIds(list);
        messageDTO.setPage(pageUrl);
        messageDTO.setTitle(title);
        messageDTO.setItems(items);

		logger.info("发送参数为corpId============:{},suitId============:{},messageDTO============:{},",corpId, config.getWxSuiteid(), JSONObject.toJSONString(messageDTO));
		
		boolean b = qywxSuiteApiService.sendMessage(corpId,config.getWxSuiteid(), messageDTO);
		logger.info("发送===============》{}",b);
		return b;
	}
	@Override
	public boolean sendAuditMessage(String clerkId, String title,
			String content, String pageUrl,int auditStatus, String auditReason) {
		Map<String,String> map = getWxUserIdByClerkId(clerkId);
		String wxUserId = map.get("wxUserId");
		String corpId = map.get("corpId");
		String name = map.get("clerkName");

		if(jodd.util.StringUtil.isEmpty(wxUserId)){
			logger.info("wxUserId不存在============clerkId={}",clerkId);
			return false;
		}
		if(content.length()>30){
			content = content.substring(0, 26);
			content = content+"...";
		}
		//先发送下，试试
		QywxXcxSendMessageDTO messageDTO = new QywxXcxSendMessageDTO();
		List<ItemDTO> items = new ArrayList();;
		ItemDTO dto1 = new ItemDTO();
		ItemDTO dto2 = new ItemDTO();
		ItemDTO dto3 = new ItemDTO();
		ItemDTO dto4 = new ItemDTO();

		dto1.setKey("接收人");
		dto1.setValue(name);
		dto2.setKey("接收事件");
		dto2.setValue(content);
		dto3.setKey("结果");
		dto3.setValue(auditStatus == 1?"已同意":"已拒绝");
		dto4.setKey("理由");
		dto4.setValue(auditReason);
		items.add(dto1);
		items.add(dto2);
        ArrayList<String> list = new ArrayList<>();
        list.add(wxUserId);
		messageDTO.setAppid(config.getAppid());
        messageDTO.setUserIds(list);
        messageDTO.setPage(pageUrl);
        messageDTO.setTitle(title);
        messageDTO.setItems(items);

		logger.info("发送参数为corpId============:{},suitId============:{},messageDTO============:{},",corpId, config.getWxSuiteid(), JSONObject.toJSONString(messageDTO));
		
		boolean b = qywxSuiteApiService.sendMessage(corpId,config.getWxSuiteid(), messageDTO);
		logger.info("发送===============》{}",b);
		return b;
	}
	@Override
	public String getPageUrl(int type, String data) {
		String baseUrl = "/pages/route/index";
		String addurl = AppPageType.getDescByCode(type);
		String url = "";
		if(type ==  AppPageType.INDEX.getCode()){
			//工作台
			url = baseUrl+"?pageType="+addurl;
		}else{
			url = baseUrl+"?pageType="+addurl;
		}
		url = url+"&data=";
		String encodeData = URLEncoder.encode(data);
		url = url+encodeData;
		return url;
	}

}
